%
% MALLA DE HEXAEDROS PARA UN CUBO DE LADO UNITARIO
%


clear all;
hold off;

%Definicion de variables%

syms('NUMx','NUMy','NUMz','CUBO','ARISTA','PUNTO','X','Y','Z','velu','velv','Tiempototal','dt','conta','cont','contx','conty','radcont','OK','T','K');
syms('X0','Y0','Z0','A','B','C','D','s','NUMarista','NT','CC','AM','BM','CM');
syms('u','v','w','EXISTEarista','EXISTEnodo','deltaX','deltaY','deltaZ');
syms('COLUMNAarista','pos1','pos2','i','j','k','m','h','p','q','numD','NUMnodo','auxiliar','r');
syms('NumPuntosx','NumPuntosy','NumPuntosz','SUMA','hnivel','hprevio','nivel','h1','I','J')

%Vectores de movimiento%

u=[0 0 1 1 0 0 1 1];
v=[0 1 1 0 0 1 1 0];
w=[0 0 0 0 1 1 1 1];

CUBO=0;
PUNTO=1;
ARISTA=1;
 TRUE = 1;
 FALSE = 0;

fprintf(1,'Introduzca la velocidad en la direccion x \n');
velu = input(' ');
fprintf(1,'Introduzca la velocidad en la direccion y \n');
velv = input(' ');
fprintf(1,'Introduzca el tiempo total \n');
Tiempototal = input(' ');
OK = FALSE;
 while OK == FALSE
    fprintf(1,'Introduzca el incremento de tiempo  \n');
    dt = input(' ');
    if dt < Tiempototal & dt > 0
        OK = TRUE;
    else
        fprintf(1,'Introduzca un incremento de tiempo correcto \n\n');
    end;
 end;
OK = FALSE;
 while OK == FALSE
    fprintf(1,'Introduzca la coordenada x del centro del contaminante \n');
    contx = input(' ');
    if contx > 0 & contx < 1
        OK = TRUE;
    else
        fprintf(1,'La coordenada x tiene que estar entre 0 y 1 \n\n');
    end;
 end;
OK = FALSE;
 while OK == FALSE
    fprintf(1,'Introduzca la coordenada y del centro del contaminante \n');
    conty = input(' ');
    if conty > 0 & conty < 1
        OK = TRUE;
    else
        fprintf(1,'La coordenada y tiene que estar entre 0 y 1 \n\n');
    end;
 end;
 OK = FALSE;
 while OK == FALSE
    fprintf(1,'Introduzca el radio de accin del contaminante \n');
    radcont = input(' ');
    if radcont < 1 & radcont > 0
        OK = TRUE;
    else
        fprintf(1,'El radio de accin del contaminante tiene que estar entre 0 y 1 \n\n');
    end;
 end;
fprintf(1,'Introduzca el valor del contaminante \n');
cont = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion x\n');
NUMx = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion y\n');
NUMy = input(' ');
fprintf(1,'Introduzca el numero de puntos en la direccion z\n');
NUMz = input(' ');

NumPuntosz=NUMz+1;
NumPuntosy=NUMy+1;
NumPuntosx=NUMx+1;
deltaX=1/NUMx;
deltaY=1/NUMy;
deltaZ=1/NUMz;

%Bucle de generacion de hexaedros%

for k=1:NUMz
    
    Z0=(k-1)*deltaZ;
    
	for j=1:NUMy
		Y0=(j-1)*deltaY;
		
		for i=1:NUMx
			X0=(i-1)*deltaX;
			CUBO=CUBO+1;

			for r=1:8
			C(r)=0;
			end;

			for h=1:8
				
				X=X0+u(h)*deltaX;
				Y=Y0+v(h)*deltaY;
				Z=Z0+w(h)*deltaZ;
				
				EXISTEnodo=0;
				p=1;

				while p<PUNTO & EXISTEnodo==0

					if coordX(p)==X & coordY(p)==Y & coordZ(p)==Z
						
						EXISTEnodo=1;
						NUMnodo=p;
					else
						
						p=p+1;
					end;
				end;
				
				if EXISTEnodo==1
					C(h)=NUMnodo;
				else
					coordX(PUNTO)=X;
					coordY(PUNTO)=Y;
					coordZ(PUNTO)=Z;
					C(h)=PUNTO;
					PUNTO=PUNTO+1;
				end;
			end;

               
            for q=1:8
                
                D(CUBO,q)=C(q);
                
            end;
            
%Creacin de aristas

			for COLUMNAarista=1:12
				
				pos1=COLUMNAarista;
				pos2=COLUMNAarista+1;
				
				if pos2==5
					pos2=1;
				end;
				
				if pos2==9
					pos2=5;
				end;
				
				if COLUMNAarista>8
					pos1=COLUMNAarista-8;
					pos2=pos1+4;
				end;
                    
                    a=double(C(pos1));
                    b=double(C(pos2));
                    
				if a > b
					auxiliar=pos1;
					pos1=pos2;
					pos2=auxiliar;
				end;
                
                a=C(pos1);
                b=C(pos2);

				EXISTEarista=0;
				s=1;
				
				while s<ARISTA & EXISTEarista==0

					if B(1,s)==C(pos1) & B(2,s)==C(pos2)

						EXISTEarista=1;
						NUMarista=s;
					else
						s=s+1;
					end;
				end;
				
				if EXISTEarista==1
					A(CUBO,COLUMNAarista)=NUMarista;
					
				else
					A(CUBO,COLUMNAarista)=ARISTA;
					B(1,ARISTA)=C(pos1);
                    B(2,ARISTA)=C(pos2);
                    
                    UNO=subs(a);
                    DOS=subs(b);
                    
                    %Dibujar cada arista en el momento que se crea%
                    DibujarX(1)=coordX(UNO);
                    DibujarX(2)=coordX(DOS);
                    DibujarY(1)=coordY(UNO);
                    DibujarY(2)=coordY(DOS);
                    DibujarZ(1)=coordZ(UNO);
                    DibujarZ(2)=coordZ(DOS);
                   
                    plot3(DibujarX,DibujarY,DibujarZ);
                    hold on;
                                       
					ARISTA=ARISTA+1;
				end;
			end;

		end;
	end;
end;


%CREACION DEL FICHERO CON TODAS LAS RELACIONES ENTRE NODOS,ARISTAS Y CUBOS%

 fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
 fprintf(1,'Por ejemplo:  A:\\OUTPUT.DTA\n');
 NAME = input(' ','s');
 OUP = fopen(NAME,'wt');
 fprintf(OUP, 'MALLA HEXAEDRICA - Incremento constante\n\n');
 %Matriz A%
 fprintf(OUP, 'Matriz A relaciona cada CUBO con el nombre de sus 12 ARISTAS \n\n');
 fprintf(OUP, 'CUBO  ARISTAS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 12 
 fprintf(OUP, '  %3d', subs(A(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz D%
 fprintf(OUP, 'Matriz D relaciona cada CUBO con el nombre de sus 8 NODOS \n\n');
 fprintf(OUP, 'CUBO  NODOS\n\n');
 for I = 1 : CUBO 
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 8 
 fprintf(OUP, '  %3d', subs(D(I,J)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Matriz B%
 fprintf(OUP, 'Matriz B relaciona cada ARISTA con el nombre de sus 2 NODOS \n\n');
 fprintf(OUP, 'ARISTA  NODOS\n\n');
 for I = 1 :  (ARISTA-1)
 fprintf(OUP, ' %3d  ', I);
 for J = 1 : 2 
 fprintf(OUP, '  %3d', subs(B(J,I)));
 end;
 fprintf(OUP, '\n');
 end;
 
 fprintf(OUP, '\n\n\n');
 
 %Vectores de coordenadas%
 fprintf(OUP, 'Relacion de cada NODO con el valor de sus 3 COORDENADAS \n\n');
 fprintf(OUP, 'NODO    COORD X        COORD Y        COORD Z\n\n');
 for I = 1 :  (PUNTO-1)
 fprintf(OUP, ' %3d  ', I);
  
 fprintf(OUP, '%12.8f   %12.8f   %12.8f', coordX(I),coordY(I),coordZ(I));
 
 fprintf(OUP, '\n');
 end;
 
 fclose(OUP);

 
 %Ordenamos los datos obtenidos de la generacion de la malla

%Coordenada X

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordX(b) < coordX(interc)
             interc = b;
         end
     end
     temp = coordX(I);
     coordX(I) = coordX(interc);
     coordX(interc) = temp;
 end
 
 conta=1;
 k=coordX(conta);
 coX(conta)=k;
 
 for f = (conta+1) : (PUNTO-1)
     k=coordX(f);
     if k ~= coX(conta)
         conta=conta+1;
         coX(conta)=k;
     end
 end
 
 g=NumPuntosx;
 l=1;
 conta=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if conta == (g+1)
             conta=1;
         end
         coordX(f)=coX(conta);
         f=f+1;
         t=t+1;
     end
     conta=conta+1;
 end
 
     
 
%Coordenada Y

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordY(b) < coordY(interc)
             interc = b;
         end
     end
     temp = coordY(I);
     coordY(I) = coordY(interc);
     coordY(interc) = temp;
 end
 
 conta=1;
 k=coordY(conta);
 coY(conta)=k;
 
 for f = (conta+1) : (PUNTO-1)
     k=coordY(f);
     if k ~= coY(conta)
         conta=conta+1;
         coY(conta)=k;
     end
 end
 
 g=NumPuntosy;
 l=NumPuntosx;
 conta=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if conta == (g+1)
             conta=1;
         end
         coordY(f)=coY(conta);
         f=f+1;
         t=t+1;
     end
     conta=conta+1;
 end
 
 
 
 %Coordenada Z

 for I = 1 : (PUNTO-2)
     interc = I;
     for b = (I+1) : (PUNTO-1)
         if coordZ(b) < coordZ(interc)
             interc = b;
         end 
     end
     temp = coordZ(I);
     coordZ(I) = coordZ(interc);
     coordZ(interc) = temp;
 end
 
 conta=1;
 k=coordZ(conta);
 coZ(conta)=k;
 
 for f = (conta+1) : (PUNTO-1)
     k=coordZ(f);
     if k ~= coZ(conta)
         conta=conta+1;
         coZ(conta)=k;
     end
 end
 
 g=NumPuntosz;
 l=NumPuntosx*NumPuntosy;
 conta=1;
 f=1;
 
 while f < PUNTO-1
     t=1;
     while t <= l
         if conta == (g+1)
             conta=1;
         end
         coordZ(f)=coZ(conta);
         f=f+1;
         t=t+1;
     end
     conta=conta+1;
 end

 %subrutina para crear sistema de ecuaciones%
 
 N = NumPuntosx*NumPuntosy*NumPuntosz;
 
 for I = 1 : N
     for J = 1 : N
         AM(I,J)=0;
     end
 end
AM=zeros(N,N);
BM=zeros(1,N);
 
 for I = 1 : N
   if (coordX(I)==0) || (coordX(I)==1) || (coordY(I)==0) || (coordY(I)==1) || (coordZ(I)==0) || (coordZ(I)==1)
       AM(I,I)=1;
       DIST = (((coordX(I)-(contx))^2)+((coordY(I)-(conty))^2)+(coordZ(I))^2)^0.5;
        if DIST < radcont
            BM(I)=cont;
        else
            BM(I)=0;
        end
   else
       N1 = I - NumPuntosx*NumPuntosy - NumPuntosx;
       N2 = I - NumPuntosx*NumPuntosy - 1;
       N3 = I - NumPuntosx*NumPuntosy;
       N4 = I - NumPuntosx*NumPuntosy + 1;
       N5 = I - NumPuntosx*NumPuntosy + NumPuntosx;
       N6 = I - NumPuntosx;
       N7 = I - 1;
       N8 = I;
       N9 = I + 1;
       N10 = I + NumPuntosx;
       N11 = I + NumPuntosx*NumPuntosy - NumPuntosx;
       N12 = I + NumPuntosx*NumPuntosy - 1;
       N13 = I + NumPuntosx*NumPuntosy;
       N14 = I + NumPuntosx*NumPuntosy + 1;
       N15 = I + NumPuntosx*NumPuntosy + NumPuntosx;
   AM(I,N1)= 0;
   AM(I,N2)= 0;
   AM(I,N3)= (-(dt^2*velv^2/3)-50*dt)/(2*(1/NUMz)^2);
   AM(I,N4)= 0;
   AM(I,N5)= 0;
   AM(I,N6)= ((-(dt^2*velv^2/3)-50*dt)/(1/NUMy)^2)-(-5*10^(-4)*dt^2*velv)/(2*(1/NUMy));
   AM(I,N7)= ((-(dt^2*velu^2/3)-50*dt)/(1/NUMx)^2)-(-5*10^(-4)*dt^2*velu)/(2*(1/NUMx));
   AM(I,N8)= (1+6*10^(-4)*dt)-(2*(-(dt^2*velu^2/3)-50*dt)/(1/NUMx)^2)-(2*(-(dt^2*velv^2/3)-50*dt)/(1/NUMy)^2)-((-50*dt)*2/(2*(1/NUMz)^2));
   AM(I,N9)= ((-(dt^2*velu^2/3)-50*dt)/(1/NUMx)^2)+(-5*10^(-4)*dt^2*velu)/(2*(1/NUMx));
   AM(I,N10)= ((-(dt^2*velv^2/3)-50*dt)/(1/NUMy)^2)+(-5*10^(-4)*dt^2*velv)/(2*(1/NUMy));
   AM(I,N11)= 0;
   AM(I,N12)= 0;
   AM(I,N13)= (-50*dt)/(2*(1/NUMz)^2);
   AM(I,N14)= 0;
   AM(I,N15)= 0;
   end
 end
 NT=fix(Tiempototal/dt);
 CMT=zeros(NT,N);
 CM=zeros(N);
 CC=zeros(NumPuntosx,NumPuntosy);
 for T = 1 : NT
	%CM = bicgstab(AM,BM',1e-6);
    CM=AM^(-1)*BM';
    CMT(T,:)=CM;
	for I=1:N
        if (coordX(I)==0) || (coordX(I)==1) || (coordY(I)==0) || (coordY(I)==1) || (coordZ(I)==0) || (coordZ(I)==1)
            DIST = (((coordX(I)-(contx))^2)+((coordY(I)-(conty))^2)+(coordZ(I))^2)^0.5;
            if DIST < radcont
                BM(I)=cont;
            else
                BM(I)=0;
            end
        else
            BM(I)=((1+(dt/2)*(-0.0012)-(dt^2/2)*(-0.0012)^2)*CM(I)+((2/3)*dt^2*(velu)^2-dt^2*(-0.0012)*50)*((CM(I-1)-2*CM(I)+CM(I+1))/(1/NUMx)^2)+((2/3)*dt^2*(velv)^2-dt^2*(-0.0012)*50)*((CM(I-NUMx)-2*CM(I)+CM(I+NUMx))/(1/NUMy)^2)-dt^2*(-0.0012)*50+((4/3)*dt^2*(velu)*(velv))*((CM(I+1+NUMx)-CM(I-1+NUMx)-CM(I+1-NUMx)+CM(I-1-NUMx))/(4*(1/NUMx)*(1/NUMy)))+((5/12)*dt^2*(-0.0012)*velu-dt*velu)*((CM(I+1)-CM(I-1))/(2*(1/NUMx)))+((5/12)*dt^2*(-0.0012)*velv-dt*velv)*((CM(I+NUMx)-CM(I-NUMx))/(2*(1/NUMy))))
        end    
	end
	if rem(NT,10)==0
        icapa=2;
        for J = 1:NumPuntosx
            x(J)=(J-1)/NUMx;
        end
        for K=1:NumPuntosy
            y(K)=(K-1)/NUMy;
        end
        nodo1=NumPuntosx*NumPuntosy*(icapa-1)+1;
        npcapa=NumPuntosx*NumPuntosy;
        for J=1:NumPuntosy
            for I=1:NumPuntosx
                K=NumPuntosx*NumPuntosy*(icapa-1)+(J-1)*NumPuntosx+I;
                CC(I,J)=CM(K);
            end
        end
        figure(T+1);
        surf(x,y,CC);
    end
 end